<?php
G::LoadClass("plugin");

class deleteCasesPlugin extends PMPlugin
{
  private $dashletsUids;
  
  public function deleteCasesPlugin($sNamespace, $sFilename = null)
  {
    $res = parent::PMPlugin($sNamespace, $sFilename);
    $this->sFriendlyName = "deleteCases Plugin";
    $this->sDescription  = "Autogenerated plugin for class deleteCases";
    $this->sPluginFolder = "deleteCases";
    $this->sSetupPage    = "";
    $this->iVersion      = 1;
    $this->iPMVersion    = 2425;
    //$this->aWorkspaces   = null;
    //$this->aWorkspaces = array("os");
    
    
    $this->dashletsUids = array(
      array("DAS_UID" => "815582275590d80785f1dc2000424360",
            "DAS_CLASS" => "dashletdeleteCases",
            "DAS_TITLE" => "Dashlet deleteCases",
            "DAS_DESCRIPTION" => "Dashlet deleteCases",
            "DAS_VERSION" => "1.0",
            "DAS_CREATE_DATE" => date("Y-m-d"),
            "DAS_UPDATE_DATE" => date("Y-m-d"))
    );
    
    
    return $res;
  }

  public function setup()
  {
    $this->setCompanyLogo("/plugin/deleteCases/deleteCases.png");
    $this->registerMenu("processmaker", "menudeleteCases.php");
    $this->registerMenu("cases", "menuCasesdeleteCases.php");
    $this->registerStep("104370117590d80772c1111078904589", "stepdeleteCasesApplication", "deleteCases external step");
    $this->registerPmFunction();
    $this->redirectLogin("PROCESSMAKER_DELETECASES", "users/users_List");
    
    $this->registerDashlets();
  }

  public function install()
  {
    $RBAC = RBAC::getSingleton() ;
    $RBAC->initRBAC();
    $roleData = array();
    $roleData["ROL_UID"] = G::GenerateUniqueId();
    $roleData["ROL_PARENT"] = "";
    $roleData["ROL_SYSTEM"] = "00000000000000000000000000000002";
    $roleData["ROL_CODE"] = "PROCESSMAKER_DELETECASES";
    $roleData["ROL_CREATE_DATE"] = date("Y-m-d H:i:s");
    $roleData["ROL_UPDATE_DATE"] = date("Y-m-d H:i:s");
    $roleData["ROL_STATUS"] = "1";
    $RBAC->createRole($roleData);
    $RBAC->createPermision("PM_DELETECASES");
  }
  
  public function enable()
  {
    $this->dashletInsert();
	$this->enableRestService(true);
  }

  public function disable()
  {
    $this->dashletDelete();
  }
  
  public function dashletInsert()
  {
    require_once ("classes/model/Dashlet.php");
    
    $connection = Propel::getConnection(DashletPeer::DATABASE_NAME);
    
    foreach ($this->dashletsUids as $dashletData) {
      $dashlet = new Dashlet();
      
      if (is_null($dashlet->load($dashletData["DAS_UID"]))) {
        $dashlet->fromArray($dashletData, BasePeer::TYPE_FIELDNAME);
        $connection->begin();
        $dashlet->save();
        $connection->commit();
      }
    }
  }
  
  public function dashletDelete()
  {
    require_once ("classes/model/Dashlet.php");
    
    foreach ($this->dashletsUids as $dashletData) {
      $criteria = new Criteria("workflow");
      $criteria->add(DashletPeer::DAS_UID, $dashletData["DAS_UID"]);
      DashletPeer::doDelete($criteria);
    }
  }
}

$oPluginRegistry = PMPluginRegistry::getSingleton();
$oPluginRegistry->registerPlugin("deleteCases", __FILE__);
